﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.TextBox;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace LAB19
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        List<Point> pontok = new List<Point>(); //üres lista
        Random randi = new Random();
        Graphics gr;
        Bitmap bmp;

        // Inicalizálás
        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Síkidom";
            label1.Text = "Sokszög";
            label2.Text = "Méret";
            label3.Text = "Irány";
            checkBox1.Text = "Random";
            numericUpDown1.Minimum = 3;
            numericUpDown2.Minimum = 10;
            numericUpDown3.Maximum = 359;
        }

        //Egér kilikkelés figyelése
        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                Point pont = new Point(e.X, e.Y);
                pontok.Add(pont);
            }
            else if (e.Button == MouseButtons.Right)
            {
                int meret = pontok.Count;
                if (meret > 0) pontok.RemoveAt(meret - 1);
            }

            Rajz();
        }

        // Rajzolási funkció
        void Rajz()
        {
            bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            gr = Graphics.FromImage(bmp);

            int num = pontok.Count;

            //összekötő poligon
            if (num > 2)
            {
                gr.DrawPolygon(Pens.Black, pontok.ToArray());
            }

            int n = (int)numericUpDown1.Value;
            int l = (int)numericUpDown2.Value;
            int f = (int)numericUpDown3.Value;

            //alakzatok
            for (int i = 0; i < num; ++i)
            {
                Color szin = Color.FromArgb(randi.Next(256), randi.Next(256), randi.Next(256));
                
                if (checkBox1.Checked) //Random értékekkel rajzol
                {
                    n = randi.Next(3, 10);
                    l = randi.Next(10, 100);
                    f = randi.Next(360);
                }

                PointF[] csucsPontok = new PointF[n]; //csúcspontok
                for (int j = 0; j < csucsPontok.Length; j++)
                {
                    csucsPontok[j].X = (float)(l * Math.Sin(j * 2 * Math.PI / n));
                    csucsPontok[j].Y = (float)(l * Math.Cos(j * 2 * Math.PI / n));
                }
                // mindig a bal felső sarokpontból induljon a koordináta rendszer
                gr.ResetTransform();
                gr.TranslateTransform(pontok[i].X, pontok[i].Y);
                gr.RotateTransform(f);
                gr.FillPolygon(new SolidBrush(szin), csucsPontok);
            }

            // megjelenítés
            pictureBox1.Image = bmp;
        }

        // Adatok törlése
        private void képekTörléseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pontok.Clear();
            Rajz();
        }

        // alakzatok mentése
        private void alakzatokMentéseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Pontok|*.txt";
            saveFileDialog.FileName = "";
            if (saveFileDialog.ShowDialog() == DialogResult.Cancel) return;

            using (StreamWriter sw = new StreamWriter(saveFileDialog.FileName))
            {
                foreach (Point elem in pontok)
                {
                    sw.WriteLine($"{elem.X}\t{elem.Y}");
                }
            }

        }

        // aéalzatok beolvasása
        private void alakzatokBeolvasásaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "Pontok|*.txt";
            openFileDialog.FileName = "";
            if (openFileDialog.ShowDialog() == DialogResult.Cancel) return;

            using (StreamReader streamReader = new StreamReader(openFileDialog.FileName))
            {
                pontok.Clear();
                while (!streamReader.EndOfStream)
                {
                    string sor = streamReader.ReadLine();

                    if (sor.Contains('\t'))
                    {
                        string[] resz = sor.Split('\t');
                        int x = Convert.ToInt32(resz[0]);
                        int y = Convert.ToInt32(resz[1]);
                        Point p = new Point(x, y);
                        pontok.Add(p);
                    }
                }
            }
            Rajz();
        }

        // Mentés képként
        private void mentésKépkéntToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bmp.Save("..//..//background.png", System.Drawing.Imaging.ImageFormat.Png);
        }
    }
}
